'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.StaRHType = exports.StaRH = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _tcomb = require('tcomb');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var PositiveIntegerType = (0, _tcomb.refinement)(_tcomb.Number, function (n) {
  return n > 0 && n % 1 === 0;
}, 'PositiveIntegerType');

var StaRH = exports.StaRH = function () {
  /**
   * @param {{from: string, to: string, amount: number, message: string}} fields
   */
  function StaRH(fields) {
    _classCallCheck(this, StaRH);

    var from = fields.from,
        to = fields.to,
        amount = fields.amount,
        message = fields.message;

    (0, _tcomb.String)(from);
    (0, _tcomb.String)(to);
    PositiveIntegerType(amount);
    (0, _tcomb.String)(message);
    this.from = from;
    this.to = to;
    this.amount = amount;
    this.message = message;
    this.$context = this.constructor.$context;
  }

  /**
   * @param {{email: string, firstname: string, lastname: string, avatar: string}} data
   * @returns {StaRH}
   */


  _createClass(StaRH, null, [{
    key: 'fromJSON',
    value: function fromJSON(data) {
      return new StaRH(data);
    }

    /**
     * @returns {string}
     */

  }, {
    key: '$context',
    get: function get() {
      return 'https://github.com/ResourcefulHumans/staRHs-models#StaRH';
    }
  }]);

  return StaRH;
}();

var StaRHType = exports.StaRHType = (0, _tcomb.irreducible)('StaRHType', function (x) {
  return x instanceof StaRH;
});