'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.StaRHsStatusType = exports.StaRHsStatus = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _tcomb = require('tcomb');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var ZeroOrPositiveIntegerType = (0, _tcomb.refinement)(_tcomb.Number, function (n) {
  return n >= 0 && n % 1 === 0;
}, 'ZeroOrPositiveIntegerType');

var StaRHsStatus = exports.StaRHsStatus = function () {
  /**
   * @param {{cycleShared: number, cycleReceived: number, cycleLeft: number, totalShared: number, totalReceived: number}} fields
   */
  function StaRHsStatus(fields) {
    _classCallCheck(this, StaRHsStatus);

    var cycleShared = fields.cycleShared,
        cycleReceived = fields.cycleReceived,
        cycleLeft = fields.cycleLeft,
        totalShared = fields.totalShared,
        totalReceived = fields.totalReceived;

    ZeroOrPositiveIntegerType(cycleShared);
    ZeroOrPositiveIntegerType(cycleReceived);
    ZeroOrPositiveIntegerType(cycleLeft);
    ZeroOrPositiveIntegerType(totalShared);
    ZeroOrPositiveIntegerType(totalReceived);
    this.cycleShared = cycleShared;
    this.cycleReceived = cycleReceived;
    this.cycleLeft = cycleLeft;
    this.totalShared = totalShared;
    this.totalReceived = totalReceived;
    this.$context = this.constructor.$context;
  }

  /**
   * @param {{cycleShared: number, cycleReceived: number, cycleLeft: number, totalShared: number, totalReceived: number}} data
   * @returns {StaRHsStatus}
   */


  _createClass(StaRHsStatus, null, [{
    key: 'fromJSON',
    value: function fromJSON(data) {
      return new StaRHsStatus(data);
    }

    /**
     * @returns {string}
     */

  }, {
    key: '$context',
    get: function get() {
      return 'https://github.com/ResourcefulHumans/staRHs-models#StaRHsStatus';
    }
  }]);

  return StaRHsStatus;
}();

var StaRHsStatusType = exports.StaRHsStatusType = (0, _tcomb.irreducible)('StaRHsStatusType', function (x) {
  return x instanceof StaRHsStatus;
});